Packager: Igor Vlasenko <viy@altlinux.ru>
BuildRequires: /proc
BuildRequires: jpackage-compat
# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support 0

# If you don't want to build with maven, and use straight ant instead,
# give rpmbuild option '--without maven'

%define with_maven %{!?_without_maven:1}%{?_without_maven:0}
%define without_maven %{?_without_maven:1}%{!?_without_maven:0}

%define namedversion    4.0-alpha5
%define sname    httpcore

Name:           hc-httpcore
Version:        4.0
Release:        alt1_0.a5.1jpp5
Epoch:          0
Summary:        HTTPCore components
License:        Apache Software License 2.0
Url:            http://hc.apache.org/
Group:          Development/Java
Source0:        %{name}-%{namedversion}-src.tar.gz
# svn http://svn.apache.org/repos/asf/httpcomponents/httpcore/tags/4.0-alpha5/ hc-httpcore

Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Source3:        jakarta-httpcomponents-pom.xml
Patch0:         %{name}-pom_xml.patch

BuildRequires: jpackage-utils >= 0:1.7.5
BuildRequires: ant >= 0:1.6.5
BuildRequires: junit >= 0:3.8.2
%if %{with_maven}
BuildRequires: maven2 >= 2.0.7
BuildRequires: maven2-plugin-assembly
BuildRequires: maven2-plugin-compiler
BuildRequires: maven2-plugin-install
BuildRequires: maven2-plugin-jar
BuildRequires: maven2-plugin-javadoc
BuildRequires: maven2-plugin-resources
BuildRequires: maven2-plugin-site
BuildRequires: maven-release
BuildRequires: maven-surefire-plugin
%endif
Requires(post): jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5
%if %{gcj_support}
BuildRequires: gnu-crypto
BuildRequires: java-gcj-compat-devel
Requires(post): java-gcj-compat
Requires(postun): java-gcj-compat
%endif
Provides:       jakarta-httpcore = %{epoch}:%{version}-%{release}
Obsoletes:      jakarta-httpcore < %{epoch}:%{version}-%{release}

%if ! %{gcj_support}
BuildArch:      noarch
%endif

%description
HttpCore components implement the most fundamental aspects 
of the HTTP protocol that are nonetheless sufficient to 
develop full-featured client-side and server-side HTTP 
services with a minimal footprint.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q -n %{name}
cp %{SOURCE1} settings.xml
mkdir -p .m2/repository/JPP/maven2/default_poms/
cp %{SOURCE3} .m2/repository/JPP/maven2/default_poms/org.apache.httpcomponents-project.pom
%patch0 -b .sav

%build
%if %{with_maven}
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" settings.xml

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

mvn-jpp \
        -e \
        -s $(pwd)/settings.xml \
        -Dmaven.test.failure.ignore=true \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        install

mvn-jpp \
        -e \
        -s $(pwd)/settings.xml \
        -Daggregate=true \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        javadoc:javadoc

%else
ant -Djunit.jar=$(build-classpath junit) \
     package test javadoc
%endif


%install
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/httpcomponents
%if %{with_maven}
install -m 644 module-main/target/%{sname}-%{namedversion}.jar \
               $RPM_BUILD_ROOT%{_javadir}/httpcomponents/%{sname}-%{version}.jar
install -m 644 module-nio/target/%{sname}-nio-%{namedversion}.jar \
               $RPM_BUILD_ROOT%{_javadir}/httpcomponents/%{sname}-nio-%{version}.jar
install -m 644 module-niossl/target/%{sname}-niossl-%{namedversion}.jar \
               $RPM_BUILD_ROOT%{_javadir}/httpcomponents/%{sname}-niossl-%{version}.jar
%else
install -m 644 dist/%{name}-SNAPSHOT.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
install -m 644 dist/%{name}-nio-SNAPSHOT.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}-nio-%{version}.jar
install -m 644 dist/%{name}-niossl-SNAPSHOT.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}-niossl-%{version}.jar
%endif

(cd $RPM_BUILD_ROOT%{_javadir}/httpcomponents && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir} && ln -s httpcomponents/httpcore.jar jakarta-httpcore.jar && ln -s httpcomponents/httpcore-nio.jar jakarta-httpcore-nio.jar)

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 %{SOURCE3} \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.httpcomponents-project.pom
%add_to_maven_depmap org.apache.httpcomponents project %{namedversion} JPP/httpcomponents project
install -m 644 pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.httpcomponents-core.pom
%add_to_maven_depmap org.apache.httpcomponents httpcomponents-core %{namedversion} JPP/httpcomponents core
install -m 644 module-main/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.httpcomponents-httpcore.pom
%add_to_maven_depmap org.apache.httpcomponents httpcore %{namedversion} JPP/httpcomponents httpcore
install -m 644 module-nio/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.httpcomponents-httpcore-nio.pom
%add_to_maven_depmap org.apache.httpcomponents httpcore-nio %{namedversion} JPP/httpcomponents httpcore-nio
install -m 644 module-niossl/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.httpcomponents-httpcore-niossl.pom
%add_to_maven_depmap org.apache.httpcomponents httpcore-niossl %{namedversion} JPP/httpcomponents httpcore-niossl

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
%if %{with_maven}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
%else
cp -pr dist/docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
%endif
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink


%if %{gcj_support}
export CLASSPATH=$(build-classpath gnu-crypto)
%{_bindir}/aot-compile-rpm
%endif

%files
%{_javadir}/*.jar
%{_javadir}/httpcomponents/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%{_libdir}/gcj/%{name}/%{name}-*%{version}.jar.*
%endif

%files javadoc
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%changelog
* Tue Mar 03 2009 Igor Vlasenko <viy@altlinux.ru> 0:4.0-alt1_0.a5.1jpp5
- first build

